#! /usr/bin/env bash
# Args: <config-file> <arch> <builder-args> [<repo>]

if [ -z "$BUILD_DIR" ]; then
    BUILD_DIR=build
fi

# Reset env
while read i
do
    unset "$i"
done < <(printenv | cut -d '=' -f 1 | grep -vE '^(PWD|PATH|HOME|BUILD_DIR)$')
printenv &&

# Build
CONFIG_DIR="$(dirname "$0")" &&
flatpak-builder $3 --arch "$2" --install-deps-from=winebarrels --install-deps-only "$BUILD_DIR" "$1" &&
(find '.flatpak-builder/build' -delete || rm -rf ".flatpak-builder/build/*" ".flatpak-builder/build/.*") &&
if [ -z "$4" ]; then
    BUILD_DIR= exec flatpak-builder $3 --arch "$2" --sandbox --rebuild-on-sdk-change "$BUILD_DIR" "$1"
else
    HASH="$("$CONFIG_DIR/hash_modules.py" --installed "$1" "$2" | sed -n '1p')" || exit 0 &&
    if [ -z "$DELETE_CACHE" ]
    then
        BUILD_DIR= exec flatpak-builder $3 --arch "$2" --sandbox --rebuild-on-sdk-change --repo "$4" -s "WB_HASH='${HASH}'" "$BUILD_DIR" "$1"
    else
        (find .flatpak-builder/cache -delete || rm -rf .flatpak-builder/cache) &&
        BUILD_DIR= flatpak-builder $3 --arch "$2" --sandbox --rebuild-on-sdk-change --repo "$4" -s "WB_HASH='${HASH}'" "$BUILD_DIR" "$1"
    fi
fi